--All credit to Bob.
--Bob's Stupid Castbar (aka BSC)
--Config
--Available fonts are ARIALN.ttf, FRIZQT__.ttf, MORPHEUS.ttf, SKURRI.ttf
                                
local font = "Fonts\\FRIZQT__.ttf"
local style = "nil" --OUTLINE MONOCHROME ect

--[[Player castbar]]--
local height = 16
local width = 180
local Point = "CENTER"
local positionX = 0
local positionY = -98
local textsize = height-2 --So the text scales with the Bar height
local Iconsize = 16

--[[target castbar]]--
local height2 = 16
local width2 = 180
local Point2 = "CENTER"
local positionX2 = 0
local positionY2 = 0
local textsize2 = height2-2
local Iconsize2 = 16

--[[focus castbar]]--Size is affected by the toggle option "Larger Focus Frame"
local height3 = 16
local width3 = 120
local Point3 = "TOP"
local positionX3 = 0
local positionY3 = 10
local textsize3 = height3-2
local Iconsize3 = 16
--------------------------------------------------------------------------------------------------
------------------------------------------[[END CONFIG]]------------------------------------------
--------------------------------------------------------------------------------------------------
cbf = "CastingBarFrame"
tbf = "TargetFrameSpellBar"
fbf = "FocusFrameSpellBar"

--Player castbar
_G[cbf]:SetSize(width,height)
_G[cbf]:SetScale("1.0")
_G[cbf]:ClearAllPoints()
_G[cbf]:SetPoint(Point, UIParent, positionX, positionY)
_G[cbf].SetPoint = function() end


--Target Castbar
_G[tbf]:SetSize(width2,height2)
_G[tbf]:SetScale("1.0")
_G[tbf]:ClearAllPoints()
_G[tbf]:SetPoint(Point2, UIParent, positionX2, positionY2)
_G[tbf].SetPoint = function() end


--Focus Castbar
-- _G[fbf]:SetSize(width3,height3)
-- _G[fbf]:SetScale("1.0")
-- _G[fbf]:ClearAllPoints()
-- _G[fbf]:SetPoint(Point3, FocusFrame, "TOP", positionX3, positionY3)
-- _G[fbf].SetPoint = function() end


--Castbar timer from thek
_G[cbf].timer = _G[cbf]:CreateFontString("FontString","OVERLAY","GameTooltipText")
_G[cbf].timer:SetPoint("RIGHT", _G[cbf], "RIGHT", 24, 0)
_G[cbf].timer:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
_G[cbf].update = .1

_G[tbf].timer = _G[tbf]:CreateFontString("FontString","OVERLAY","GameTooltipText")
_G[tbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
_G[tbf].timer:SetPoint("RIGHT", _G[tbf], "RIGHT", 24, 0)
_G[tbf].update = .1

-- _G[fbf].timer = _G[fbf]:CreateFontString("FontString","OVERLAY","GameTooltipText")
-- _G[fbf].timer:SetFont("Fonts\\FRIZQT__.ttf", 12, "THINOUTLINE")
-- _G[fbf].timer:SetPoint("RIGHT", _G[fbf], "RIGHT", 24, 0)
-- _G[fbf].update = .1

hooksecurefunc("CastingBarFrame_OnUpdate", function(self, elapsed)
	if not self.timer then return end
	if self.update and self.update < elapsed then
		if self.casting then
			self.timer:SetText(format("%.1f", max(self.maxValue - self.value, 0)))
		elseif self.channeling then
			self.timer:SetText(format("%.1f", max(self.value, 0)))
		else
			self.timer:SetText("")
		end
		self.update = .1
	else
		self.update = self.update - elapsed
	end
end)