-- Deja Tweaks
--Register Events
local DejaTweaksEventFrame = CreateFrame("Frame", "DejaTweaksEventFrame")
	DejaTweaksEventFrame:RegisterEvent("PLAYER_LOGIN")
	DejaTweaksEventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
	DejaTweaksEventFrame:RegisterEvent("ADDON_LOADED")
	DejaTweaksEventFrame:RegisterEvent("MERCHANT_SHOW")
	DejaTweaksEventFrame:RegisterEvent("AUCTION_HOUSE_SHOW")
	-- DejaTweaksEventFrame:RegisterEvent("PET_BATTLE_OVER")

	DejaTweaksEventFrame:SetScript("OnEvent", function(self, event, ...)
		--Sell Junk
		if (event == "MERCHANT_SHOW") then
			local bag, slot
			for bag = 0, 4 do
				for slot = 0, GetContainerNumSlots(bag) do
					local link = GetContainerItemLink(bag, slot)
					if link and (select(3, GetItemInfo(link)) == 0) then
						UseContainerItem(bag, slot)
					end
				end
			end
			-- Auto Repair
			--function DVGBankRepair()
				if(CanMerchantRepair()) then
					local cost = GetRepairAllCost()
					if cost >0 then
						if GetMoney() >= cost then
							RepairAllItems()
							print(format("|cffffff00Repair costs covered by "..UnitName("player")..": %.2fg|r", cost * 0.0001))
						else
							print(format("|cffff0000"..UnitName("player").."has insufficient funds to cover repair costs.|r"))
						end
					elseif cost >0 and GetMoney() >= cost then
						RepairAllItems()
						print(format("|cffffff00Repair costs covered by "..UnitName("player")..": %.2fg|r", cost * 0.0001))
					elseif GetMoney() < cost then
						print(format("|cffff0000"..UnitName("player").."has insufficient funds to cover repair costs.|r"))
					end
				end
			--end
		end
		if (event == "AUCTION_HOUSE_SHOW") then
			AuctionFrame:ClearAllPoints()
			AuctionFrame:SetPoint("TOP", (GetScreenWidth()/16),-(GetScreenHeight()/4))
			local function MoveAHBags()
				if BagnonInventoryFrame1 then
					BagnonInventoryFrame1:ClearAllPoints()
					BagnonInventoryFrame1:SetPoint("TOPLEFT", AuctionFrame, "TOPRIGHT", 0, 0)

					BagnonInventoryFrame1:SetScript("OnShow", function(self)
					if AuctionFrame:IsVisible() then return
					else
						BagnonInventoryFrame1:ClearAllPoints()
						BagnonInventoryFrame1:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", 0, (GetScreenHeight()/8))
					end
	
					end)

				end
			end
			C_Timer.After(0.1, MoveAHBags)
		end
		-- SinStats frame
		if SinStatsFrame then
			SinStatsFrame:SetSize(200, 15)
			SinStatsFrame:ClearAllPoints()
			SinStatsFrame:SetPoint('BOTTOM', UIParent, 'BOTTOM', -300, 120)
		end
	end)

--Slash Commands
	SlashCmdList['RELOADUI'] = function() ReloadUI() end
	SLASH_RELOADUI1 = '/rl'

	SlashCmdList["READYCHECK"] = function() DoReadyCheck() end
	SLASH_READYCHECK1 = '/rc'

	SlashCmdList["CHECKROLE"] = function() InitiateRolePoll() end
	SLASH_CHECKROLE1 = '/cr'
	
--Choonster's Spell Off Cursor Button
local b = CreateFrame("Button", "SpellStopTargetingButton", UIParent, "SecureActionButtonTemplate")
	b:SetAttribute("type", "stop")
	
--eAlign by Eurytus
SLASH_EA1 = "/align"
local f

SlashCmdList["EA"] = function()
	if f then
		f:Hide()
		f = nil		
	else
		f = CreateFrame('Frame', nil, UIParent) 
		f:SetAllPoints(UIParent)
		local w = GetScreenWidth() / 64
		local h = GetScreenHeight() / 36
		for i = 0, 64 do
			local t = f:CreateTexture(nil, 'BACKGROUND')
			if i == 32 then
				t:SetColorTexture(1, 0, 0, 0.5)
			else
				t:SetColorTexture(0, 0, 0, 0.5)
			end
			t:SetPoint('TOPLEFT', f, 'TOPLEFT', i * w - 1, 0)
			t:SetPoint('BOTTOMRIGHT', f, 'BOTTOMLEFT', i * w + 1, 0)
		end
		for i = 0, 36 do
			local t = f:CreateTexture(nil, 'BACKGROUND')
			if i == 18 then
				t:SetColorTexture(1, 0, 0, 0.5)
			else
				t:SetColorTexture(0, 0, 0, 0.5)
			end
			t:SetPoint('TOPLEFT', f, 'TOPLEFT', 0, -i * h + 1)
			t:SetPoint('BOTTOMRIGHT', f, 'TOPRIGHT', 0, -i * h - 1)
		end	
	end
end

---------------
-- World Map --
---------------

-- local _, private = ...
-- 	private.defaults.dvdefaults.WorldMapFrameSetPoints = {
-- 		point = "TOPLEFT", 
-- 		relativeTo = "UIParent", 
-- 		relativePoint = "TOPLEFT", 
-- 		xOffset = 0, 
-- 		yOffset = 0,
-- 	}	
	
-- -- Information Stat Frame Parent
-- 	WorldMapFrame:SetClampedToScreen(true)
-- 	WorldMapFrame:SetMovable(true) 
-- 	WorldMapFrame:EnableMouse(true)
-- 	WorldMapFrame:RegisterForDrag("LeftButton")

-- 	WorldMapFrame:HookScript("OnShow", function(self)
-- 		WorldMapFrame.BlackoutFrame:Hide()
-- 		WorldMapFrame.BlackoutFrame.Blackout:Hide()
		
-- 		local function DVC_MoveWMap()
-- 			local point = private.db.dvdefaults.WorldMapFrameSetPoints
-- 				self:ClearAllPoints()		
-- 				self:SetPoint(
-- 					point.point, 
-- 					point.relativeTo, 
-- 					point.relativePoint, 
-- 					point.xOffset, 
-- 					point.yOffset)
-- 		end
-- 		C_Timer.After(0.0001, DVC_MoveWMap)
-- 	end)
	
-- 	WorldMapFrame:HookScript("OnDragStart", WorldMapFrame.StartMoving) 

-- 	WorldMapFrame:HookScript("OnDragStop", function(self) 
-- 		self:StopMovingOrSizing() 
-- 		self:SetUserPlaced(false) 
		
-- 		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
-- 			if ( relativeTo ) then
-- 				relativeTo = relativeTo:GetName();
-- 			else
-- 				relativeTo = self:GetParent():GetName();
-- 			end
	
-- 		-- These are debugging messages for the frame points
-- 		-- Un-comment them to help debug
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(point)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
-- 		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)

-- 		private.db.dvdefaults.WorldMapFrameSetPoints.point = point
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.relativeTo = relativeTo
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.relativePoint = relativePoint
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.xOffset = xOfs
-- 		private.db.dvdefaults.WorldMapFrameSetPoints.yOffset = yOfs			
-- 	end)


-- 	local _, private = ...
-- 	private.defaults.dvdefaults.WMSliderSetScale = {
-- 		WorldMapScale = 0.50,
-- 	}	


-- -- WorldMap Slider:
-- local WMSlider = CreateFrame("Slider", "WMSlider", WorldMapFrame, "OptionsSliderTemplate")
-- 	WMSlider:RegisterEvent("PLAYER_LOGIN")
-- 	WMSlider:RegisterEvent("PLAYER_ENTERING_WORLD")
-- 	WMSlider:RegisterEvent("ADDON_LOADED")
-- 	WMSlider:SetPoint("TOPLEFT", WorldMapFrame, "TOPLEFT", 25, -37)
-- 	WMSlider:SetWidth(200)
-- 	WMSlider:SetHeight(10)
-- 	WMSlider:SetOrientation('HORIZONTAL')
-- 	WMSlider:SetMinMaxValues(0.25, 1.0)
-- 	WMSlider.minValue, WMSlider.maxValue = WMSlider:GetMinMaxValues() 
-- 	WMSlider:SetValueStep(0.01)
-- 	WMSlider:SetObeyStepOnDrag(true)

-- 	WMSlider.tooltipText = 'Scale the WorldMap in increments or decrements of 5' --Creates a tooltip on mouseover.

-- 	getglobal(WMSlider:GetName() .. 'Low'):SetText(WMSlider.minValue); --Sets the left-side slider text (default is "Low").
-- 	getglobal(WMSlider:GetName() .. 'High'):SetText(WMSlider.maxValue); --Sets the right-side slider text (default is "High").

-- 	WMSlider:SetScript("OnEvent", function(self, event, arg1)
-- 		if event == "PLAYER_LOGIN" then
-- 		local slideValue = private.db.dvdefaults.WMSliderSetScale.WorldMapScale
-- 			WMSlider:SetValue(slideValue)
-- 			WorldMapFrame:SetScale(slideValue)
-- 			getglobal(WMSlider:GetName() .. 'Text'):SetFormattedText("WorldMap Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).

-- 			-- WorldMapFrame.BorderFrame:SetParent(WorldMapFrame)
-- 			-- WorldMapFrame.ScrollContainer:SetScale(slideValue)
-- 			-- WorldMapFrame.ScrollContainer.Child:SetParent(WorldMapFrame)
-- 			WorldMapFrame.ScrollContainer.Child.TiledBackground:SetParent(WorldMapFrame)
-- 			-- local kids = { WorldMapFrame.ScrollContainer.Child:GetChildren() };
-- 			-- for _, child in pairs(kids) do
-- 			-- 	WorldMapFrame.ScrollContainer.Child[child]:SetScale(slideValue)
-- 			-- 	WorldMapFrame.ScrollContainer.Child._.HighlightTexture:SetScale(slideValue)
-- 			-- end
-- 		end
-- 	end)

-- 	WorldMapFrame.BorderFrame:SetScript("OnMouseWheel", function(self, input)
-- 		local slideValue = private.db.dvdefaults.WMSliderSetScale.WorldMapScale
-- 		if input > 0 and slideValue < 1 then
-- 			slideValue = (slideValue + 0.01)
-- 			if slideValue > 1 then slideValue = 1 end
-- 			WorldMapFrame:SetScale(slideValue)
-- 		elseif input < 0 and slideValue > 0.25 then
-- 			slideValue = (slideValue - 0.01)
-- 			if slideValue < 0.25 then slideValue = 0.25 end
-- 			WorldMapFrame:SetScale(slideValue)
-- 		end
-- 		getglobal(WMSlider:GetName() .. 'Text'):SetFormattedText("World Map Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).
-- 		private.db.dvdefaults.WMSliderSetScale.WorldMapScale = slideValue
-- 		WMSlider:SetValue(slideValue)
-- 	end)

-- 	WMSlider:SetScript("OnValueChanged", function(self, value) 
-- 		local slideValue = WMSlider:GetValue()
-- 			WorldMapFrame:SetScale(slideValue)
						
-- 			getglobal(WMSlider:GetName() .. 'Text'):SetFormattedText("World Map Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).
-- 			private.db.dvdefaults.WMSliderSetScale.WorldMapScale = slideValue
-- 		end)	